﻿using System;
using System.Collections.Generic;

namespace TestProject
{
    /// <summary>
    /// 항목 리스트 이벤트 인자
    /// </summary>
    public class ItemListEventArgs : EventArgs
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region Field

        /// <summary>
        /// 뷰
        /// </summary>
        private DataGridCollectionView view;

        /// <summary>
        /// 시작 인덱스
        /// </summary>
        private int startIndex;
        
        /// <summary>
        /// 요청 항목 수
        /// </summary>
        private int requestedItemCount;
        
        /// <summary>
        /// 항목 리스트
        /// </summary>
        private IList<object> itemList;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Internal

        #region 항목 리스트 - ItemList

        /// <summary>
        /// 항목 리스트
        /// </summary>
        internal IList<object> ItemList => this.itemList;

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 요청 항목 수 - RequestedItemCount

        /// <summary>
        /// 요청 항목 수
        /// </summary>
        public int RequestedItemCount => this.requestedItemCount;

        #endregion
        #region 시작 인덱스 - StartIndex

        /// <summary>
        /// 시작 인덱스
        /// </summary>
        public int StartIndex => this.startIndex;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - ItemListEventArgs(view, startIndex, requestedItemCount)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="view">뷰</param>
        /// <param name="startIndex">시작 인덱스</param>
        /// <param name="requestedItemCount">요청 항목 수</param>
        public ItemListEventArgs(DataGridCollectionView view, int startIndex, int requestedItemCount)
        {
            this.view = view;

            this.startIndex = startIndex;

            this.requestedItemCount = requestedItemCount;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 항목 리스트 설정하기 - SetItemList(itemList)

        /// <summary>
        /// 항목 리스트 설정하기
        /// </summary>
        /// <param name="itemList">항목 리스트</param>
        public void SetItemList(IList<object> itemList)
        {
            this.itemList = itemList;
        }

        #endregion
    }
}